gi-gtk3-3.0.44: Gtk 3.x bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.Clipboard

Contents

- Exported types
- Methods
  - clear
  - get
  - getDefault
  - getDisplay
  - getForDisplay
  - getOwner
  - getSelection
  - requestContents
  - requestImage
  - requestRichText
  - requestTargets
  - requestText
  - requestUris
  - setCanStore
  - setImage
  - setText
  - store
  - waitForContents
  - waitForImage
  - waitForTargets
  - waitForText
  - waitForUris
  - waitIsImageAvailable
  - waitIsRichTextAvailable
  - waitIsTargetAvailable
  - waitIsTextAvailable
  - waitIsUrisAvailable
- Signals
  - ownerChange

Description

The `Clipboard` object represents a clipboard of data shared between different processes or between different widgets in the same process. Each clipboard is identified by a name encoded as a `Atom`. (Conversion to and from strings can be done with `atomIntern` and `atomName`.) The default clipboard corresponds to the “CLIPBOARD” atom; another commonly used clipboard is the “PRIMARY” clipboard, which, in X, traditionally contains the currently selected text.

To support having a number of different formats on the clipboard at the same time, the clipboard mechanism allows providing callbacks instead of the actual data. When you set the contents of the clipboard, you can either supply the data directly (via functions like `clipboardSetText`), or you can supply a callback to be called at a later time when the data is needed (via `gtk_clipboard_set_with_data()` or `gtk_clipboard_set_with_owner()`.) Providing a callback also avoids having to make copies of the data when it is not needed.

`gtk_clipboard_set_with_data()` and `gtk_clipboard_set_with_owner()` are quite similar; the choice between the two depends mostly on which is more convenient in a particular situation. The former is most useful when you want to have a blob of data with callbacks to convert it into the various data types that you advertise. When the `clearFunc` you provided is called, you simply free the data blob. The latter is more useful when the contents of clipboard reflect the internal state of a `Object` (As an example, for the PRIMARY clipboard, when an entry widget provides the clipboard’s contents the contents are simply the text within the selected region.) If the contents change, the entry widget can call `gtk_clipboard_set_with_owner()` to update the timestamp for clipboard ownership, without having to worry about `clearFunc` being called.

Requesting the data from the clipboard is essentially asynchronous. If the contents of the clipboard are provided within the same process, then a direct function call will be made to retrieve the data, but if they are provided by another process, then the data needs to be retrieved from the other process, which may take some time. To avoid blocking the user interface, the call to request the selection, `clipboardRequestContents` takes a callback that will be called when the contents are received (or when the request fails.) If you don’t want to deal with providing a separate callback, you can also use `clipboardWaitForContents`. What this does is run the GLib main loop recursively waiting for the contents. This can simplify the code flow, but you still have to be aware that other callbacks in your program can be called while this recursive mainloop is running.

Along with the functions to get the clipboard contents as an arbitrary data chunk, there are also functions to retrieve it as text, `clipboardRequestText` and `clipboardWaitForText`. These functions take care of determining which formats are advertised by the clipboard provider, asking for the clipboard in the best available format and converting the results into the UTF-8 encoding. (The standard form for representing strings in GTK+.)

Synopsis

- newtype Clipboard = Clipboard (ManagedPtr Clipboard)
- class (GObject o, IsDescendantOf Clipboard o) => IsClipboard o
- toClipboard :: (MonadIO m, IsClipboard o) => o -> m Clipboard
- clipboardClear :: (HasCallStack, MonadIO m, IsClipboard a) => a -> m ()
- clipboardGet :: (HasCallStack, MonadIO m) => Atom -> m Clipboard
- clipboardGetDefault :: (HasCallStack, MonadIO m, IsDisplay a) => a -> m Clipboard
- clipboardGetDisplay :: (HasCallStack, MonadIO m, IsClipboard a) => a -> m Display
- clipboardGetForDisplay :: (HasCallStack, MonadIO m, IsDisplay a) => a -> Atom -> m Clipboard
- clipboardGetOwner :: (HasCallStack, MonadIO m, IsClipboard a) => a -> m (Maybe Object)
- clipboardGetSelection :: (HasCallStack, MonadIO m, IsClipboard a) => a -> m Atom
- clipboardRequestContents :: (HasCallStack, MonadIO m, IsClipboard a) => a -> Atom -> ClipboardReceivedFunc -> m ()
- clipboardRequestImage :: (HasCallStack, MonadIO m, IsClipboard a) => a -> ClipboardImageReceivedFunc -> m ()
- clipboardRequestRichText :: (HasCallStack, MonadIO m, IsClipboard a, IsTextBuffer b) => a -> b -> ClipboardRichTextReceivedFunc -> m ()
- clipboardRequestTargets :: (HasCallStack, MonadIO m, IsClipboard a) => a -> ClipboardTargetsReceivedFunc -> m ()
- clipboardRequestText :: (HasCallStack, MonadIO m, IsClipboard a) => a -> ClipboardTextReceivedFunc -> m ()
- clipboardRequestUris :: (HasCallStack, MonadIO m, IsClipboard a) => a -> ClipboardURIReceivedFunc -> m ()
- clipboardSetCanStore :: (HasCallStack, MonadIO m, IsClipboard a) => a -> Maybe [TargetEntry] -> m ()
- clipboardSetImage :: (HasCallStack, MonadIO m, IsClipboard a, IsPixbuf b) => a -> b -> m ()
- clipboardSetText :: (HasCallStack, MonadIO m, IsClipboard a) => a -> Text -> Int32 -> m ()
- clipboardStore :: (HasCallStack, MonadIO m, IsClipboard a) => a -> m ()
- clipboardWaitForContents :: (HasCallStack, MonadIO m, IsClipboard a) => a -> Atom -> m (Maybe SelectionData)
- clipboardWaitForImage :: (HasCallStack, MonadIO m, IsClipboard a) => a -> m (Maybe Pixbuf)
- clipboardWaitForTargets :: (HasCallStack, MonadIO m, IsClipboard a) => a -> m (Bool, [Atom])
- clipboardWaitForText :: (HasCallStack, MonadIO m, IsClipboard a) => a -> m (Maybe Text)
- clipboardWaitForUris :: (HasCallStack, MonadIO m, IsClipboard a) => a -> m (Maybe [Text])
- clipboardWaitIsImageAvailable :: (HasCallStack, MonadIO m, IsClipboard a) => a -> m Bool
- clipboardWaitIsRichTextAvailable :: (HasCallStack, MonadIO m, IsClipboard a, IsTextBuffer b) => a -> b -> m Bool
- clipboardWaitIsTargetAvailable :: (HasCallStack, MonadIO m, IsClipboard a) => a -> Atom -> m Bool
- clipboardWaitIsTextAvailable :: (HasCallStack, MonadIO m, IsClipboard a) => a -> m Bool
- clipboardWaitIsUrisAvailable :: (HasCallStack, MonadIO m, IsClipboard a) => a -> m Bool
- type ClipboardOwnerChangeCallback = EventOwnerChange -> IO ()
- afterClipboardOwnerChange :: (IsClipboard a, MonadIO m) => a -> ((?self :: a) => ClipboardOwnerChangeCallback) -> m SignalHandlerId
- onClipboardOwnerChange :: (IsClipboard a, MonadIO m) => a -> ((?self :: a) => ClipboardOwnerChangeCallback) -> m SignalHandlerId

# Exported types

newtype Clipboard Source #

Memory-managed wrapper type.

Constructors

Clipboard (ManagedPtr Clipboard) |

#### Instances

Instances details

Eq Clipboard Source # |
Instance details Defined in GI.Gtk.Objects.Clipboard Methods (==) :: Clipboard -> Clipboard -> Bool Source # (/=) :: Clipboard -> Clipboard -> Bool Source #
GObject Clipboard Source # |
Instance details Defined in GI.Gtk.Objects.Clipboard
ManagedPtrNewtype Clipboard Source # |
Instance details Defined in GI.Gtk.Objects.Clipboard Methods toManagedPtr :: Clipboard -> ManagedPtr Clipboard Source #
TypedObject Clipboard Source # |
Instance details Defined in GI.Gtk.Objects.Clipboard Methods glibType :: IO GType Source #
HasParentTypes Clipboard Source # |
Instance details Defined in GI.Gtk.Objects.Clipboard
IsGValue (Maybe Clipboard) Source # | Convert `Clipboard` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.Clipboard Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe Clipboard -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe Clipboard) Source #
type ParentTypes Clipboard Source # |
Instance details Defined in GI.Gtk.Objects.Clipboard type ParentTypes Clipboard = '[Object]

class (GObject o, IsDescendantOf Clipboard o) => IsClipboard o Source #

Type class for types which can be safely cast to `Clipboard`, for instance with `toClipboard`.

#### Instances

Instances details

(GObject o, IsDescendantOf Clipboard o) => IsClipboard o Source # |
Instance details Defined in GI.Gtk.Objects.Clipboard

toClipboard :: (MonadIO m, IsClipboard o) => o -> m Clipboard Source #

Cast to `Clipboard`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, clear, forceFloating, freezeNotify, getv, isFloating, notify, notifyByPspec, ref, refSink, requestContents, requestImage, requestRichText, requestTargets, requestText, requestUris, runDispose, stealData, stealQdata, store, thawNotify, unref, waitForContents, waitForImage, waitForRichText, waitForTargets, waitForText, waitForUris, waitIsImageAvailable, waitIsRichTextAvailable, waitIsTargetAvailable, waitIsTextAvailable, waitIsUrisAvailable, watchClosure.

#### Getters

getData, getDisplay, getOwner, getProperty, getQdata, getSelection.

#### Setters

setCanStore, setData, setDataFull, setImage, setProperty, setText.

## clear

clipboardClear Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> m () |

Clears the contents of the clipboard. Generally this should only be called between the time you call `gtk_clipboard_set_with_owner()` or `gtk_clipboard_set_with_data()`, and when the `clearFunc` you supplied is called. Otherwise, the clipboard may be owned by someone else.

## get

clipboardGet Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Atom | `selection`: a `Atom` which identifies the clipboard to use
-> m Clipboard | Returns: the appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent and, since it is owned by GTK+, must not be freed or unreffed.

Returns the clipboard object for the given selection. See `clipboardGetForDisplay` for complete details.

## getDefault

clipboardGetDefault Source #

Arguments

:: (HasCallStack, MonadIO m, IsDisplay a) |
=> a | `display`: the `Display` for which the clipboard is to be retrieved.
-> m Clipboard | Returns: the default clipboard object.

Returns the default clipboard object for use with cut/copy/paste menu items and keyboard shortcuts.

Since: 3.16

## getDisplay

clipboardGetDisplay Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> m Display | Returns: the `Display` associated with `clipboard`

Gets the `Display` associated with `clipboard`

Since: 2.2

## getForDisplay

clipboardGetForDisplay Source #

Arguments

:: (HasCallStack, MonadIO m, IsDisplay a) |
=> a | `display`: the `Display` for which the clipboard is to be retrieved or created.
-> Atom | `selection`: a `Atom` which identifies the clipboard to use.
-> m Clipboard | Returns: the appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent and, since it is owned by GTK+, must not be freed or unrefd.

Returns the clipboard object for the given selection. Cut/copy/paste menu items and keyboard shortcuts should use the default clipboard, returned by passing `GDK_SELECTION_CLIPBOARD` for `selection`. (`GDK_NONE` is supported as a synonym for GDK_SELECTION_CLIPBOARD for backwards compatibility reasons.) The currently-selected object or text should be provided on the clipboard identified by `GDK_SELECTION_PRIMARY`. Cut/copy/paste menu items conceptually copy the contents of the `GDK_SELECTION_PRIMARY` clipboard to the default clipboard, i.e. they copy the selection to what the user sees as the clipboard.

(Passing `GDK_NONE` is the same as using `gdk_atom_intern ("CLIPBOARD", FALSE)`.

See the FreeDesktop Clipboard Specification for a detailed discussion of the “CLIPBOARD” vs. “PRIMARY” selections under the X window system. On Win32 the `GDK_SELECTION_PRIMARY` clipboard is essentially ignored.)

It’s possible to have arbitrary named clipboards; if you do invent new clipboards, you should prefix the selection name with an underscore (because the ICCCM requires that nonstandard atoms are underscore-prefixed), and namespace it as well. For example, if your application called “Foo” has a special-purpose clipboard, you might call it “_FOO_SPECIAL_CLIPBOARD”.

Since: 2.2

## getOwner

clipboardGetOwner Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> m (Maybe Object) | Returns: the owner of the clipboard, if any; otherwise `Nothing`.

If the clipboard contents callbacks were set with `gtk_clipboard_set_with_owner()`, and the `gtk_clipboard_set_with_data()` or `clipboardClear` has not subsequently called, returns the owner set by `gtk_clipboard_set_with_owner()`.

## getSelection

clipboardGetSelection Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> m Atom | Returns: the selection

Gets the selection that this clipboard is for.

Since: 3.22

## requestContents

clipboardRequestContents Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> Atom | `target`: an atom representing the form into which the clipboard owner should convert the selection.
-> ClipboardReceivedFunc | `callback`: A function to call when the results are received (or the retrieval fails). If the retrieval fails the length field of `selectionData` will be negative.
-> m () |

Requests the contents of clipboard as the given target. When the results of the result are later received the supplied callback will be called.

## requestImage

clipboardRequestImage Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> ClipboardImageReceivedFunc | `callback`: a function to call when the image is received, or the retrieval fails. (It will always be called one way or the other.)
-> m () |

Requests the contents of the clipboard as image. When the image is later received, it will be converted to a `Pixbuf`, and `callback` will be called.

The `pixbuf` parameter to `callback` will contain the resulting `Pixbuf` if the request succeeded, or `Nothing` if it failed. This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into an image.

Since: 2.6

## requestRichText

clipboardRequestRichText Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a, IsTextBuffer b) |
=> a | `clipboard`: a `Clipboard`
-> b | `buffer`: a `TextBuffer`
-> ClipboardRichTextReceivedFunc | `callback`: a function to call when the text is received, or the retrieval fails. (It will always be called one way or the other.)
-> m () |

Requests the contents of the clipboard as rich text. When the rich text is later received, `callback` will be called.

The `text` parameter to `callback` will contain the resulting rich text if the request succeeded, or `Nothing` if it failed. The `length` parameter will contain `text`’s length. This function can fail for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into rich text form.

Since: 2.10

## requestTargets

clipboardRequestTargets Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> ClipboardTargetsReceivedFunc | `callback`: a function to call when the targets are received, or the retrieval fails. (It will always be called one way or the other.)
-> m () |

Requests the contents of the clipboard as list of supported targets. When the list is later received, `callback` will be called.

The `targets` parameter to `callback` will contain the resulting targets if the request succeeded, or `Nothing` if it failed.

Since: 2.4

## requestText

clipboardRequestText Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> ClipboardTextReceivedFunc | `callback`: a function to call when the text is received, or the retrieval fails. (It will always be called one way or the other.)
-> m () |

Requests the contents of the clipboard as text. When the text is later received, it will be converted to UTF-8 if necessary, and `callback` will be called.

The `text` parameter to `callback` will contain the resulting text if the request succeeded, or `Nothing` if it failed. This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into text form.

## requestUris

clipboardRequestUris Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> ClipboardURIReceivedFunc | `callback`: a function to call when the URIs are received, or the retrieval fails. (It will always be called one way or the other.)
-> m () |

Requests the contents of the clipboard as URIs. When the URIs are later received `callback` will be called.

The `uris` parameter to `callback` will contain the resulting array of URIs if the request succeeded, or `Nothing` if it failed. This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into URI form.

Since: 2.14

## setCanStore

clipboardSetCanStore Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> Maybe [TargetEntry] | `targets`: array containing information about which forms should be stored or `Nothing` to indicate that all forms should be stored.
-> m () |

Hints that the clipboard data should be stored somewhere when the application exits or when gtk_clipboard_store () is called.

This value is reset when the clipboard owner changes. Where the clipboard data is stored is platform dependent, see gdk_display_store_clipboard () for more information.

Since: 2.6

## setImage

clipboardSetImage Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a, IsPixbuf b) |
=> a | `clipboard`: a `Clipboard` object
-> b | `pixbuf`: a `Pixbuf`
-> m () |

Sets the contents of the clipboard to the given `Pixbuf`. GTK+ will take responsibility for responding for requests for the image, and for converting the image into the requested format.

Since: 2.6

## setText

clipboardSetText Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard` object
-> Text | `text`: a UTF-8 string.
-> Int32 | `len`: length of `text`, in bytes, or -1, in which case the length will be determined with `strlen()`.
-> m () |

Sets the contents of the clipboard to the given UTF-8 string. GTK+ will make a copy of the text and take responsibility for responding for requests for the text, and for converting the text into the requested format.

## store

clipboardStore Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> m () |

Stores the current clipboard data somewhere so that it will stay around after the application has quit.

Since: 2.6

## waitForContents

clipboardWaitForContents Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> Atom | `target`: an atom representing the form into which the clipboard owner should convert the selection.
-> m (Maybe SelectionData) | Returns: a newly-allocated `SelectionData` object or `Nothing` if retrieving the given target failed. If non-`Nothing`, this value must be freed with `selectionDataFree` when you are finished with it.

Requests the contents of the clipboard using the given target. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

## waitForImage

clipboardWaitForImage Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> m (Maybe Pixbuf) | Returns: a newly-allocated `Pixbuf` object which must be disposed with `objectUnref`, or `Nothing` if retrieving the selection data failed. (This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into an image.)

Requests the contents of the clipboard as image and converts the result to a `Pixbuf`. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

Since: 2.6

## waitForTargets

clipboardWaitForTargets Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> m (Bool, [Atom]) | Returns: `True` if any targets are present on the clipboard, otherwise `False`.

Returns a list of targets that are present on the clipboard, or `Nothing` if there aren’t any targets available. The returned list must be freed with `free`. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

Since: 2.4

## waitForText

clipboardWaitForText Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> m (Maybe Text) | Returns: a newly-allocated UTF-8 string which must be freed with `free`, or `Nothing` if retrieving the selection data failed. (This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into text form.)

Requests the contents of the clipboard as text and converts the result to UTF-8 if necessary. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

## waitForUris

clipboardWaitForUris Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> m (Maybe [Text]) | Returns: a newly-allocated `Nothing`-terminated array of strings which must be freed with `strfreev`, or `Nothing` if retrieving the selection data failed. (This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into URI form.)

Requests the contents of the clipboard as URIs. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

Since: 2.14

## waitIsImageAvailable

clipboardWaitIsImageAvailable Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> m Bool | Returns: `True` is there is an image available, `False` otherwise.

Test to see if there is an image available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the supported image targets. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

This function is a little faster than calling `clipboardWaitForImage` since it doesn’t need to retrieve the actual image data.

Since: 2.6

## waitIsRichTextAvailable

clipboardWaitIsRichTextAvailable Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a, IsTextBuffer b) |
=> a | `clipboard`: a `Clipboard`
-> b | `buffer`: a `TextBuffer`
-> m Bool | Returns: `True` is there is rich text available, `False` otherwise.

Test to see if there is rich text available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the supported rich text targets. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

This function is a little faster than calling `clipboardWaitForRichText` since it doesn’t need to retrieve the actual text.

Since: 2.10

## waitIsTargetAvailable

clipboardWaitIsTargetAvailable Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> Atom | `target`: A `Atom` indicating which target to look for.
-> m Bool | Returns: `True` if the target is available, `False` otherwise.

Checks if a clipboard supports pasting data of a given type. This function can be used to determine if a “Paste” menu item should be insensitive or not.

If you want to see if there’s text available on the clipboard, use gtk_clipboard_wait_is_text_available () instead.

Since: 2.6

## waitIsTextAvailable

clipboardWaitIsTextAvailable Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> m Bool | Returns: `True` is there is text available, `False` otherwise.

Test to see if there is text available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the supported text targets. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

This function is a little faster than calling `clipboardWaitForText` since it doesn’t need to retrieve the actual text.

## waitIsUrisAvailable

clipboardWaitIsUrisAvailable Source #

Arguments

:: (HasCallStack, MonadIO m, IsClipboard a) |
=> a | `clipboard`: a `Clipboard`
-> m Bool | Returns: `True` is there is an URI list available, `False` otherwise.

Test to see if there is a list of URIs available to be pasted This is done by requesting the TARGETS atom and checking if it contains the URI targets. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

This function is a little faster than calling `clipboardWaitForUris` since it doesn’t need to retrieve the actual URI data.

Since: 2.14

# Signals

## ownerChange

type ClipboardOwnerChangeCallback Source #

Arguments

= EventOwnerChange | `event`: the `gdkEventOwnerChange` event
-> IO () |

The ownerChange signal is emitted when GTK+ receives an event that indicates that the ownership of the selection associated with `clipboard` has changed.

Since: 2.6

afterClipboardOwnerChange :: (IsClipboard a, MonadIO m) => a -> ((?self :: a) => ClipboardOwnerChangeCallback) -> m SignalHandlerId Source #

Connect a signal handler for the ownerChange signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after clipboard #ownerChange callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onClipboardOwnerChange :: (IsClipboard a, MonadIO m) => a -> ((?self :: a) => ClipboardOwnerChangeCallback) -> m SignalHandlerId Source #

Connect a signal handler for the ownerChange signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on clipboard #ownerChange callback